//*******GLOBAL VARIABLES AND CONSTANTS ****************
#define T			 567		// Size of table
#define R 		 566		// root position
#define N			 4096 	// Size of string buffer(default=4096)
#define F			 30 		// Size of look-ahead buffer 	(default=60) 3 -:- 150 
#define NIL		 N			// End of tree's node

unsigned char	 getlen,
			 				 putlen,
			 				 *text_buf;
unsigned int	 match_position,
							 getbuf,
							 putbuf,
							 *freq;
int						 *lson,
							 *rson,
							 *dad,
							 *prnt,
							 *son,
							 match_length,
							 flag;

//+-+-+-+-+-+-+ +-+ +-+-+-+-+-+-+-+-+-+-+-+-+-+
//|C|o|m|m|o|n| |2| |E|n|c|o|d|e|&|D|e|c|o|d|e|
//+-+-+-+-+-+-+ +-+ +-+-+-+-+-+-+-+-+-+-+-+-+-+
//*****************RECONST*********************
//COMPLETELY REWRITED by Lionel Debroux
static inline void reconst(void)
{	int 				 i, 
							 j, 
							 k;
	unsigned int f, 
							 l,
							 *ptr  = son, 
							 *ptr2 = freq, 
							 *ptr3 = ptr, 
							 *ptr4 = ptr2;

	for (i = T; (i--);) 
	{	if (*ptr >= (unsigned)T){	*ptr4++ = (*ptr2 + 1) / 2;	*ptr3++ = *ptr;}
		ptr++ ;
		ptr2++;
	}
	for (i = 0, j = 284/*NCHAR*/; j < T; i += 2, j++) // make a tree : first, connect children nodes
	{	k 	 = i + 1;
		f 	 = freq[j] = freq[i] + freq[k];
		k 	 = j - 1;
		ptr  = &freq[j];
		while (f < *--ptr) k--;
  	k++;
		l 	 = (j - k);
		ptr  = &freq[j]; // k+l
		ptr2 = &freq[j+1]; // k+l+1
		for (;(l--);) *--ptr2 = *--ptr;
		*ptr = f;
    l = (j - k); // We destroyed it, so we must recalculate it.
		ptr  = &son[j]; // k+l
		ptr2 = &son[j+1]; // k+l+1
		for (;(l--);) *--ptr2 = *--ptr;
		*ptr = i;
	}
	ptr = son;	// connect parent nodes
	for (i = 0; i < T; i++) 
	{ k = *ptr++;
		prnt[k] = i;
		if (k < T) prnt[k + 1] = i;
	}
}
//**************UPDATE*****************
static inline void update(int c)
{	int 				 i, 
							 j, 
							 l;
	unsigned int k;
	
	if (freq[R] == 0x700) reconst();
	c = prnt[c + T];
	do 
	{	k = ++freq[c];
		// swap nodes to keep the tree freq-ordered
		if (k > freq[l = c + 1]) 
		{	while (k > freq[++l]);
			l--;
			freq[c] = freq[l];
			freq[l] = k;
			i = son[c];
			prnt[i] = l;
			if (i < T) prnt[i + 1] = l;
			j = son[l];
			son [l] = i;
			prnt[j] = c;
			if (j < T) prnt[j + 1] = c;
			son [c] = j;
			c = l;
		}
	} while ((c = prnt[c]) != 0);// do it until reaching the root
}
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//| | | | | | | |E|n|c|o|d|i|n|g| | | | | | | | 
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//***************INSERT_NODE*******************
static inline void InsertNode(int r)
{	unsigned char *key = &text_buf[r];
	int  					p 	 = N+1 + key[0], 
								cmp  = 1,
								i;
	unsigned int 	c;

	rson[r] 		 = lson[r] = NIL;
	match_length = 0;

	for ( ; ; ) 
	{ if (cmp < 0 )
		{	if(lson[p] == NIL)
			{	 lson[p] = r;
				 dad [r] = p;
				return;
			}
			else p = lson[p];
		}
		else
		{	if(rson[p] == NIL)
			{	 rson[p] = r;
				 dad [r] = p;
				 return;
			}
			else p = rson[p];
		}
		for (i = 1; i < F; i++)	if ((cmp = key[i] - text_buf[p + i]) != 0) break;
		
		if ((i >= 2) && (i >= match_length))
		{	if (i > match_length)
			{	match_position = ((r - p) & (N - 1)) - 1;
				if ((match_length = i) >= F) break;
			}
			else if ((c = ((r - p) & (N - 1)) - 1) < match_position)	match_position = c;
		}//if
	}//for
	dad [r] = dad [p];
	lson[r] = lson[p];
	rson[r] = rson[p];
	dad[lson[p]] = r;
	dad[rson[p]] = r;
	if  (rson[dad[p]] == p) rson[dad[p]] = r;
	else lson[dad[p]] =  r;
	dad [p] = NIL;  // remove p 
}
//*******************ENCODE_CHAR***********************
static inline unsigned long EncodeChar(unsigned int c, FILE *outfile, unsigned long codesize)
{ unsigned int i = 0;
	int 				 j = 0, 
							 k = prnt[c + T];

	do 
	{	i >>= 1;
		if (k & 1) i += 0x8000;
		j++;
	} while ((k = prnt[k]) != R);
//	Putcode(j, i);
	putbuf |= i >> putlen;
	if ((putlen   += j) >= 8) 
	{	putc(putbuf >> 8, outfile);
		if ((putlen -= 8) >= 8) 
		{	putc(putbuf, outfile);
			codesize  += 2;
			putlen    -= 8;
			putbuf     = i << (j - putlen);
		} 
		else 
		{	putbuf <<= 8;
			codesize++;
		}
	}
	update(c);
	return codesize;
}
//********************ENCODE****************************
static inline unsigned long Encode(FILE *infile, FILE *outfile)
{	unsigned char p_len [64] = {0x03, 0x04, 0x04, 0x04, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x06, 0x06, 0x06, 0x06,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,	0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08},
								p_code[64] = {0x00, 0x20, 0x30, 0x40, 0x50, 0x58, 0x60, 0x68,	0x70, 0x78, 0x80, 0x88, 0x90, 0x94, 0x98, 0x9C,	0xA0, 0xA4, 0xA8, 0xAC, 0xB0, 0xB4, 0xB8, 0xBC,	0xC0, 0xC2, 0xC4, 0xC6, 0xC8, 0xCA, 0xCC, 0xCE,	0xD0, 0xD2, 0xD4, 0xD6, 0xD8, 0xDA, 0xDC, 0xDE,	0xE0, 0xE2, 0xE4, 0xE6, 0xE8, 0xEA, 0xEC, 0xEE,	0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7,	0xF8, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF},
								*pit;												//by Lionel Debroux	
	register int 	c 	 			 = 0x2020;				//by Lionel Debroux
	int						*ptr 			 = &rson[N+256+1],//by Lionel Debroux  					
								last_match_length,
								len,
								i,
								q,
								r  	 			 = N-F,
								s 	 			 = 0,
								test 			 = 0;
	unsigned long codesize 	 = 0;
	
//Inittree & modify by Lionel Debroux------------------------------------------------------
	register unsigned long buf asm("%d1") = NIL + ((unsigned long)NIL << 16);
	for (i = 256 / 4 ;(i--);)	{ *--(unsigned long *)ptr = buf; *--(unsigned long *)ptr = buf;}
	ptr = &dad[N];
	for (i = N   / 4 ;(i--);)	{	*--(unsigned long *)ptr = buf; *--(unsigned long *)ptr = buf;}
//End Inttree------------------------------------------------------------------------------
	pit = &text_buf[r];
	for (i = r / 4	 ;(i--);)	{ *--(unsigned int  *)pit = c;	 *--(unsigned int  *)pit = c;}
//End modify-------------------------------------------------------------------------------
	for (len = 0; len < F && (c = getc(infile)) != EOF; len++) text_buf[r + len] = c;

//HERE START THE REAL ENCODING ROUTINE!!!--------------------------------------------------
	do 
  {	if (match_length > len)	match_length = len;
		if (match_length <= 2) 
		{	match_length = 1;
			codesize = EncodeChar(text_buf[r], outfile, codesize);
		}
		else //id 15
		{	codesize = EncodeChar(255 - 2 + match_length, outfile, codesize);
//Encode position---------------------------------------------------------------------------
			i = match_position >> 6;
			putbuf |= ((unsigned int)p_code[i] << 8) >> putlen;
			
			if ((putlen += p_len[i]) >= 8) 
			
			{	putc(putbuf >> 8, outfile);
				if ((putlen -= 8) >= 8) 
				{	putc(putbuf, outfile);
					codesize += 2;
					putlen -= 8;

					putbuf = ((unsigned int)p_code[i] << 8) << (p_len[i] - putlen);

				}
				else 
				{	putbuf <<= 8;
					codesize++;
				}
			}
//------------------------------------------------------------------------------------------
// ATTENTION!!!   This routine is most similar to the previous! We could reduce
//								to only one like DELETE NODE....i'll think....
//Encode position---------------------------------------------------------------------------
			putbuf |= ((match_position & 0x3f) << 10) >> putlen;

			if ((putlen += 6) >= 8) 

			{	putc(putbuf >> 8, outfile);
				if ((putlen -= 8) >= 8) 
				{	putc(putbuf, outfile);
					codesize += 2;
					putlen -= 8;

					putbuf = ((match_position & 0x3f) << 10) << (6 - putlen);

				}
				else 
				{	putbuf <<= 8;
					codesize++;
				}
			}
//------------------------------------------------------------------------------------------
		}//id 15
		last_match_length = match_length;

		for (i = 0; i < last_match_length && (c = getc(infile)) != EOF; i++) 
		{
//------------------------------------------------------------------------------------------
// ATTENTION!!!   This is a simple loop to recall the DeleteNode Routine without
//								repeat it, I've incorporated in for speed up, here's better,
//								but i think that this loop can to be more optimized....Can to be used
//								a variable without declare another? (test)...Repeating
//								the routine here there is a very little bit speed up, could
//								be the new variable use???? Boh!
//DELETE NODE------------------------------------------------------------------------------
 		 test = 0;
		 goto DeleteNode;
		 ritorna:
		 test = 1;
//-----------------------------------------------------------------------------------------
		 text_buf[s] = c;
		 if (s < F - 1) text_buf[s + N] = c;
		 s = (s + 1) & (N - 1);
		 r = (r + 1) & (N - 1);
		 InsertNode(r);
		}//FOR
		while (i++ < last_match_length) 
    {
//DELETE NODE------------------------------------------------------------------------------
DeleteNode:
			if (dad[s] != NIL)
			{	if (rson[s] == NIL)	q = lson[s];
				else if (lson[s] == NIL) q = rson[s];
						 else 
						 {	q = lson[s];
								if (rson[q] != NIL) 
								{	do q = rson[q]; while (rson[q] != NIL);
									rson[dad[q]] = lson[q];
									dad[lson[q]] = dad[q];
									lson[q] = lson[s];
									dad[lson[s]] = q;
								}
								rson[q] = rson[s];
								dad[rson[s]] = q;
					 	 }
						 dad[q] = dad[s];
						 if (rson[dad[s]] == s) rson[dad[s]] = q;
						 else lson[dad[s]] = q;
						 dad[s] = NIL;
			}
			if (test == 0) goto ritorna;
//-----------------------------------------------------------------------------------------
			s = (s + 1) & (N - 1);
			r = (r + 1) & (N - 1);
			if (--len) InsertNode(r);
    }
  } while (len > 0);//end do
//ENCODE END-------------------------------------------------------------------------------
	if (putlen) { putc(putbuf >> 8, outfile);	codesize++;}
//-----------------------------------------------------------------------------------------
  return codesize;
}
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//| | | | | | | |D|e|c|o|d|i|n|g| | | | | | | | 
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//******************DECODE_CHAR****************
static inline int DecodeChar(FILE *infile)
{	int i, 
			c = son[R];

	while (c < T) 
	{	while (getlen <= 8) 
	  {	if ((i = getc(infile)) < 0) i = 0;
			else 
			{	getbuf |= i << (8 - getlen); getlen += 8;}
	  }
	  i = getbuf;
    getbuf *= 2;
	  getlen--   ;
	  c +=  (i<0);
	  c  = son[c];
	}
	c -= T;
	update(c);	
	return c;
}
//********************DECODE_POSITION*********************
static inline int DecodePosition(FILE *infile)
{ unsigned char d_code[256] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,	0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,	0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,	0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,	0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09,	0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,	0x0B, 0x0B, 0x0B, 0x0B, 0x0B, 0x0B, 0x0B, 0x0B,	0x0C, 0x0C, 0x0C, 0x0C, 0x0D, 0x0D, 0x0D, 0x0D,	0x0E, 0x0E, 0x0E, 0x0E, 0x0F, 0x0F, 0x0F, 0x0F,	0x10, 0x10, 0x10, 0x10, 0x11, 0x11, 0x11, 0x11,	0x12, 0x12, 0x12, 0x12, 0x13, 0x13, 0x13, 0x13,	0x14, 0x14, 0x14, 0x14, 0x15, 0x15, 0x15, 0x15,	0x16, 0x16, 0x16, 0x16, 0x17, 0x17, 0x17, 0x17,	0x18, 0x18, 0x19, 0x19, 0x1A, 0x1A, 0x1B, 0x1B,	0x1C, 0x1C, 0x1D, 0x1D, 0x1E, 0x1E, 0x1F, 0x1F,	0x20, 0x20, 0x21, 0x21, 0x22, 0x22, 0x23, 0x23,	0x24, 0x24, 0x25, 0x25, 0x26, 0x26, 0x27, 0x27,	0x28, 0x28, 0x29, 0x29, 0x2A, 0x2A, 0x2B, 0x2B,	0x2C, 0x2C, 0x2D, 0x2D, 0x2E, 0x2E, 0x2F, 0x2F,	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,	0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F},
								d_len [256] = {0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,	0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,	0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,	0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08};
	unsigned int  ai = getbuf,
								i  = (ai >> 8),
								j  = d_len [i],
								c  = (unsigned int)d_code[i] << 6;
	int 					y, 
								ac;
	while (getlen <= 8) {	ai=((ac=getc(infile))<0)?0:ac; 		getbuf|=ai<<(8-getlen); 	getlen+=8;}
	getbuf <<= 8;
	getlen  -= 8;
	j 			-= 2;
	while (j--) 
	{	while (getlen <= 8) 
		{	if  ((y = getc(infile)) < 0) y = 0;
			getbuf |= y << (8 - getlen);
			getlen += 8;
		}
		y = getbuf;
		getbuf <<= 1;
		getlen--;
		i = (i << 1) + (y < 0);
	}
	return c | (i & 0x3f);
}
//*********************DECODE***********************
static inline void Decode(FILE *infile, FILE *outfile, unsigned long textsize)
{ int  					i, 
								j, 
								k, 
								r = N - F;
	register int 	c = 0x2020;						//by Lionel Debroux
	unsigned char *pit = &text_buf[r];	//by Lionel Debroux	
	unsigned long count;

//Modify by Lionel Debroux-----------------------------------------------------------------
	for (i = r / 4	 ;(i--);)	{ *--(unsigned int  *)pit = c;	 *--(unsigned int  *)pit = c;}
//End modify-------------------------------------------------------------------------------
	for (count = 0; count < textsize; ) 
	{	c = DecodeChar(infile);
		if (c < 256) 
		{	putc(c, outfile);
			text_buf[r++] = c;
			r &= (N - 1);
			count++;
		} 
		else 
		{ i = (r - DecodePosition(infile) - 1) & (N - 1);
		  j = c - 255 + 2;
		  for (k = 0; k < j; k++) 
		  { c = text_buf[(i + k) & (N - 1)];
			  putc(c, outfile);
			  text_buf[r++] = c;
			  r &= (N - 1);
			  count++;
		  }
		}
	}
}
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//| | | | | | | |M|o|d|e|l| | | | | | | | | | | 
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//****************START_HUFF*******************
static inline void StartHuff(void)
{	int i, 
			j;

	for (i = 0; i < 284; i++)
	{	freq[i] = 1;
		son [i] = i + T;
		prnt[i + T] = i;
	}
	i = 0;
	j = 284;//N_CHAR
	while (j <= R) 
	{	freq[j] = freq[i] + freq[i + 1];
		son [j] = i;
		prnt[i] = prnt[i + 1] = j;
		i += 2;
		j++;
	}
	freq[T] = 0xffff;
	prnt[R] = 0;
}
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//| | | | | | | |M|a|i|n| | | | | | | | | | | | 
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
//****************PEPZIP***********************
void PepZip (const char *ingresso)
{	unsigned char 	type  [5],
									insize[40],
  							 	ftype;
  const char			*scambio  = NULL;
  unsigned long 	textsize 	= 0, 
  								codesize 	= 0;
  								//tempo1,		//uncomment to timer
  								//tempo2;		//uncomment to timer
  FILE						*infile,
  								*outfile;

//VARIABLES INITIALIZATION---------------------------------------------------------//
	match_position	= 0;
	match_length		= 0;
	getbuf					= 0;
	putbuf					= 0;
	getlen					= 0;
	putlen					= 0;
	flag						= 0;

//FILES OPEN------------------------------------------------------------------------//
  infile   = fopen(ingresso 						 , "rb");//open input file
  outfile  = fopen((scambio=tmpnam(NULL)), "wb");//open swap  file
	fsetbufsize (450, infile );//Added to speed up, could cause memory problem!!!
  fsetbufsize (450, outfile);//Added to speed up, could cause memory problem!!!

//START-----------------------------------------------------------------------------//
	if (infile == NULL)
	{ ST_helpMsg ("File not found!");//check if file exist
cleanup:
	 	fclose (infile);
	 	SymDel(SYMSTR(scambio));
		return;
	}
	if (SymFindPtr(SYMSTR(ingresso),0)->flags.flags_n & SF_ARCHIVED)//check if it's archived
	{	flag = 2;		
		if (!EM_moveSymFromExtMem(SYMSTR(ingresso),HS_NULL))
		{ ST_helpMsg("Can't unarchive file!"); goto cleanup;}
	}
// Lionel Debroux: missing else added.
	else if ( SymFindPtr(SYMSTR(ingresso),0)->flags.flags_n & SF_LOCKED)//check if it's locked
	{flag = 4;SymFindPtr(SYMSTR(ingresso),0)->flags.flags_n ^ SF_LOCKED;}

//DINAMIC ALLOCATION WITH CHECK BY LIONEL DEBROUX----------------------------------//
	// Since N <= 4096 and F <= 100, the maximum total needed memory is
	// 33191 bytes if I'm not mistaken. So, we can allocate everything at 
	// once. If the allocation fails, then we just have to free one pointer.
	// The cast to unsigned is necessary to get a correct behaviour !
	if (!(text_buf = malloc ((unsigned long)7 * N + F + 14 * 284 + 513)))
	{	ST_helpMsg ("Not enough memory!");
		if (flag == 0) flag++;
		if (flag == 2) flag = 4;
		if (flag == 3) flag = 5;
		goto cannot_allocate_memory;
	}
	lson = (int *)(text_buf + (N + F));
	rson = lson + (N + 1	 		);
	dad  = rson + (N + 257 		);
	prnt = dad  + (N + 1	 		);
	son  = prnt + (3 * 284 - 1);
	freq = son  + (2 * 284 - 1);

//FILE INPUT RECOGNITION FOR CHOICE: COMP/DECOMP-----------------------------------//
  fseek (infile, -1, SEEK_END); // go to the file tag
  textsize = ftell (infile) +1;
	if (textsize == 0) 
	{	ST_helpMsg ("0 byte file size!!!");
		flag = 1;
		goto cannot_allocate_memory;
	} 
  ftype = (char)fgetc(infile);
  StartHuff();//Common to encode and decode
  if (ftype == OTH_TAG) 
  {	fseek(infile, -6,SEEK_CUR);
  	if (getc(infile) != 0) fseek(infile, -1, SEEK_CUR);
  	fread(type,5,1,infile);
  	if (strcmp(type,"PEP") == 0)
  	{	//Displays start message
			sprintf(insize,"Extracting... Est. time: ~%lu sec.", textsize/1450);
			ST_helpMsg(insize);
  		rewind(infile);
  		if (fread(&textsize, sizeof textsize, 1, infile) < 1)
  		{ST_helpMsg("Unable to read");
  		 flag=1;
  		}
  		else 
//DECOMPRESSION-------------------------------------------------------------------//
  		{ //OSFreeTimer 						(USER_TIMER);								// Uncomment to timer
				//OSRegisterTimer (USER_TIMER, 100000); 							// Uncomment to timer
				//tempo1 = OSTimerCurVal  (USER_TIMER); 							// Uncomment to timer
				Decode  (infile, outfile, textsize );
  		  //tempo2 = OSTimerCurVal  (USER_TIMER);								// Uncomment to timer
			  //sprintf(insize,"Done! Time: %lu", (tempo1-tempo2));	// Uncomment to timer
			  sprintf(insize, "Done!");//Comment to timer
			  ST_helpMsg (insize);
  		}
  		goto cannot_allocate_memory;	
  	}
	}
//COMPRESSION----------------------------------------------------------------------//
	if (textsize < 100)
	{ST_helpMsg ("Input file too small!!!"); flag = 1;}
	else
	{ //Displays start message
		sprintf(insize,"Compressing... Est. time: ~%lu sec.", textsize/1600);
		ST_helpMsg(insize);		
		rewind(infile);
		if (fwrite(&textsize,sizeof textsize,1,outfile)<1)
	  {ST_helpMsg("Unable to write");
		  flag =1;
		}
		else
		{
		  //OSFreeTimer 		(USER_TIMER);					//Uncomment to timer
			//OSRegisterTimer (USER_TIMER, 100000); //Uncomment to timer
			//tempo1 = OSTimerCurVal  (USER_TIMER); //Uncomment to timer		 	
	 		codesize = Encode(infile , outfile);
			//tempo2 = OSTimerCurVal (USER_TIMER);  //Uncomment to timer
			fputc (ftype  , outfile);
			fputc (0		  , outfile);
			fputs ("PEP"  , outfile);
			fputc (0      , outfile);
			fputc (OTH_TAG, outfile);
			if ((codesize+13)>=textsize)
			{ ST_helpMsg ("<:( Compressed bigger than original!");
		  	if (flag == 0)
				{ flag++;
				  goto cannot_allocate_memory;
				}
				else if (flag == 2)
				{ flag = 4;
			 		goto cannot_allocate_memory;
				}
				else flag = 5;
			}
			else
			{
			  //sprintf(insize,"%.2f%% time: %lu size: %ld",	 //    Uncomment to timer	
				//		(((double)(codesize+13)/(textsize))*100),  //    Uncomment to timer	
				//		(tempo1-tempo2), (codesize+13));					 //    Uncomment to timer	
		    sprintf(insize, "Done! Src: %lu %c Pep: %ld %.2f%%", textsize+2,		  //comment to timer
		    0x12, (codesize+13), (((double)(codesize+13)/(textsize))*100));   	//comment to timer
				ST_helpMsg (insize);
			}
		}
	}
//THE END--------------------------------------------------------------------------//
cannot_allocate_memory:

	if  (text_buf) free(text_buf);
	fclose(infile);
	switch (flag)
// Lionel Debroux: reordered values so that if something goes wrong, we can simply do flag++...
	{   case 0://OK
		 	{	fclose(outfile);
				SymMove(SYMSTR(scambio), SYMSTR(ingresso));
		 	}      
	    break;
	    case 1://Error
			 	SymDel(SYMSTR(scambio));
	    break;
	    case 2://Archived
		 	{	fclose(outfile);
				SymMove(SYMSTR(scambio), SYMSTR(ingresso));	
				EM_moveSymToExtMem(SYMSTR(ingresso),HS_NULL);
		 	}         
	    break;
	    case 3://Locked
		 	{	fclose(outfile);
				SymMove(SYMSTR(scambio), SYMSTR(ingresso));
				SymFindPtr(SYMSTR(ingresso),0)->flags.bits.locked = 1;
			}
		 	break;
		 	case 4://Pep bigger than Src - Archived
		 	{	SymDel(SYMSTR(scambio));		 	
				EM_moveSymToExtMem(SYMSTR(ingresso),HS_NULL);
			}
		 	break;
		 	case 5://Pep bigger than Src - Locked
		 	{	SymDel(SYMSTR(scambio));
				SymFindPtr(SYMSTR(ingresso),0)->flags.bits.locked = 1;
			}
		 	break;
	    default:
				ST_helpMsg ("Bug, please contact Am4dEuZ!");
		    return;
  }
}